#
# Code by Steffen Gehrig
# Last modified: 7.June 2011
#
from Foundation import *
from AppKit import *
from os import chdir
import objc
import os, getpass, datetime
crtus = getpass.getuser()
date = datetime.date.today()

class backup(NSObject):
    indicator = objc.IBOutlet()

    @objc.IBAction
    def adium_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('BACKUP', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_BACKUP_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        os.chdir('/Users/' + str(crtus) + '/Library/Application Support/')
        if not os.system('zip -9 -r /Users/' + str(crtus) + '/Desktop/' + str(date) + '_adiumbackup.zip Adium\ 2.0'):
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('ADIUM_BACKUP_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('ADIUM_BACKUP_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();			

    @objc.IBAction
    def adressbook_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('BACKUP', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_BACKUP_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        os.chdir('/Users/' + str(crtus) + '/Library/Application Support/')
        if not os.system('zip -9 -r /Users/' + str(crtus) + '/Desktop/' + str(date) + '_adressbookbackup.zip AddressBook'):
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('ADDRESSBOOK_BACKUP_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('ADDRESSBOOK_BACKUP_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();	

    @objc.IBAction
    def chrome_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('BACKUP', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_BACKUP_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        os.chdir('/Users/' + str(crtus) + '/Library/Application Support/')
        if not os.system('zip -9 -r /Users/' + str(crtus) + '/Desktop/' + str(date) + '_chromebackup.zip Google -x Google/Chrome/*/History* -x Google/Chrome/*/Thumbnails -x Google/Chrome/*/Archived\ History'):
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('CHROME_BACKUP_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('CHROME_BACKUP_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();	
		
    @objc.IBAction
    def cyberduck_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('BACKUP', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_BACKUP_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        os.chdir('/Users/' + str(crtus) + '/Library/Application Support/')
        if not os.system('zip -9 -r /Users/' + str(crtus) + '/Desktop/' + str(date) + '_cyberduckbackup.zip Cyberduck'):
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('CYBERDUCK_BACKUP_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('CYBERDUCK_BACKUP_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();

    @objc.IBAction
    def firefox_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('BACKUP', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_BACKUP_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        os.chdir('/Users/' + str(crtus) + '/Library/Application Support/')
        if not os.system('zip -9 -r /Users/' + str(crtus) + '/Desktop/' + str(date) + '_firefoxbackup.zip Firefox'):
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('FIREFOX_BACKUP_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('FIREFOX_BACKUP_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
				
    @objc.IBAction
    def ical_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('BACKUP', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_BACKUP_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        os.chdir('/Users/' + str(crtus) + '/Library')
        if not os.system('zip -9 -r /Users/' + str(crtus) + '/Desktop/' + str(date) + '_icalbackup.zip Calendars Preferences/com.apple.iCal.plist'):
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('ICAL_BACKUP_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('ICAL_BACKUP_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
		
    @objc.IBAction
    def ichat_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('BACKUP', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_BACKUP_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        os.chdir('/Users/' + str(crtus) + '/Library/Preferences/')
        if not os.system('zip -9 -r /Users/' + str(crtus) + '/Desktop/' + str(date) + '_ichatbackup.zip com.apple.iChat*'):
            os.chdir('/Users/' + str(crtus) + '/Documents/')
            os.system('zip -9 -u -r /Users/' + str(crtus) + '/Desktop/' + str(date) + '_ichatbackup.zip iChats')
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('ICHAT_BACKUP_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('ICHAT_BACKUP_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();

    @objc.IBAction
    def mail_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('BACKUP', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_BACKUP_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        os.chdir('/Users/' + str(crtus) + '/Library')
        if not os.system('zip -9 -r /Users/' + str(crtus) + '/Desktop/' + str(date) + '_mailbackup.zip Mail Preferences/com.apple.mail.plist'):
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('MAIL_BACKUP_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('MAIL_BACKUP_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();

    @objc.IBAction
    def safari_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('BACKUP', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_BACKUP_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        os.chdir('/Users/' + str(crtus) + '/Library')
        if not os.system('zip -9 -r /Users/' + str(crtus) + '/Desktop/' + str(date) + '_safaribackup.zip Safari Preferences/com.apple.Safari.plist'):
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('SAFARI_BACKUP_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('SAFARI_BACKUP_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
    
    @objc.IBAction
    def things_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('BACKUP', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_BACKUP_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        os.chdir('/Users/' + str(crtus) + '/Library/Application Support/')
        if not os.system('zip -9 -r /Users/' + str(crtus) + '/Desktop/' + str(date) + '_thingsbackup.zip Cultured\ Code'):
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('THINGS_BACKUP_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('THINGS_BACKUP_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
		
    @objc.IBAction
    def thunderbird_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('BACKUP', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_BACKUP_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        os.chdir('/Users/' + str(crtus) + '/Library')
        if not os.system('zip -9 -r /Users/' + str(crtus) + '/Desktop/' + str(date) + '_thunderbirdbackup.zip Thunderbird'):
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('THUNDERBIRD_BACKUP_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('THUNDERBIRD_BACKUP_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();