#
# Code by Steffen Gehrig
# Last modified: 7.June 2011
#
from Foundation import *
from AppKit import *
import objc
import os, getpass, datetime
crtus = getpass.getuser()

class restore(NSObject):
    indicator = objc.IBOutlet()

    @objc.IBAction
    def adium_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('RESTORE', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_RESTORE_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        if not os.system('unzip -o -d /Users/' + str(crtus) + '/Desktop/ /Users/' + str(crtus) + '/Desktop/****-**-**_adiumbackup.zip'):
            os.system('killall Adium')
            os.system('rm -f -r /Users/' + str(crtus) + '/Library/Application\ Support/Adium\ 2.0')
            os.system('mv /Users/' + str(crtus) + '/Desktop/Adium\ 2.0  /Users/' + str(crtus) + '/Library/Application\ Support/')
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('ADIUM_RESTORE_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('ADIUM_RESTORE_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();

    @objc.IBAction
    def adressbook_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('RESTORE', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_RESTORE_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        if not os.system('unzip -o -d /Users/' + str(crtus) + '/Desktop/ /Users/' + str(crtus) + '/Desktop/****-**-**_adressbookbackup.zip'):
            os.system('killall Address\ Book')
            os.system('rm -f -r /Users/' + str(crtus) + '/Library/Application\ Support/AddressBook')
            os.system('mv /Users/' + str(crtus) + '/Desktop/Addressbook /Users/' + str(crtus) + '/Library/Application\ Support/')
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('ADDRESSBOOK_RESTORE_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('ADDRESSBOOK_RESTORE_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
		
    @objc.IBAction
    def chrome_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('RESTORE', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_RESTORE_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        if not os.system('unzip -o -d /Users/' + str(crtus) + '/Desktop/ /Users/' + str(crtus) + '/Desktop/****-**-**_chromebackup.zip'):
            os.system('killall Google\ Chrome')
            os.system('rm -f -r /Users/' + str(crtus) + '/Library/Application\ Support/Google')
            os.system('mv /Users/' + str(crtus) + '/Desktop/Google /Users/' + str(crtus) + '/Library/Application\ Support/')
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('CHROME_RESTORE_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('CHROME_RESTORE_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();

    @objc.IBAction
    def cyberduck_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('RESTORE', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_RESTORE_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        if not os.system('unzip -o -d /Users/' + str(crtus) + '/Desktop/ /Users/' + str(crtus) + '/Desktop/****-**-**_cyberduckbackup.zip'):
            os.system('killall Cyberduck')
            os.system('rm -f -r /Users/' + str(crtus) + '/Library/Application\ Support/Cyberduck')
            os.system('mv /Users/' + str(crtus) + '/Desktop/Cyberduck /Users/' + str(crtus) + '/Library/Application\ Support/')
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('CYBERDUCK_RESTORE_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('CYBERDUCK_RESTORE_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();

    @objc.IBAction
    def firefox_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('RESTORE', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_RESTORE_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        if not os.system('unzip -o -d /Users/' + str(crtus) + '/Desktop/ /Users/' + str(crtus) + '/Desktop/****-**-**_firefoxbackup.zip'):
            os.system('killall firefox-bin')
            os.system('rm -f -r /Users/' + str(crtus) + '/Library/Application\ Support/Firefox')
            os.system('mv /Users/' + str(crtus) + '/Desktop/Firefox /Users/' + str(crtus) + '/Library/Application\ Support/')
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('FIREFOX_RESTORE_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('FIREFOX_RESTORE_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();

    @objc.IBAction
    def ical_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('RESTORE', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_RESTORE_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        if not os.system('unzip -o -d /Users/' + str(crtus) + '/Desktop/ /Users/' + str(crtus) + '/Desktop/****-**-**_icalbackup.zip'):
            os.system('killall iCal')
            os.system('rm -f -r /Users/' + str(crtus) + '/Library/Calendars /Users/' + str(crtus) + '/Library/Preferences/com.apple.iCal.plist')
            os.system('mv /Users/' + str(crtus) + '/Desktop/Calendars /Users/' + str(crtus) + '/Library/')
            os.system('mv /Users/' + str(crtus) + '/Desktop/Preferences/com.apple.iCal.plist /Users/' + str(crtus) + '/Library/Preferences/')
            os.system('rm -f -r /Users/' + str(crtus) + '/Desktop/Preferences')
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('ICAL_RESTORE_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('ICAL_RESTORE_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();

    @objc.IBAction
    def ichat_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('RESTORE', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_RESTORE_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        if not os.system('unzip -o -d /Users/' + str(crtus) + '/Desktop/ /Users/' + str(crtus) + '/Desktop/****-**-**_ichatbackup.zip'):
            os.system('killall iChat')
            os.system('rm -f -r /Users/' + str(crtus) + '/Library/Preferences/com.apple.iChat* /Users/' + str(crtus) + '/Documents/iChats')
            os.system('mv /Users/' + str(crtus) + '/Desktop/com.apple.iChat* /Users/' + str(crtus) + '/Library/Preferences/')
            os.system('mv /Users/' + str(crtus) + '/Desktop/iChats /Users/' + str(crtus) + '/Documents/')
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('ICHAT_RESTORE_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('ICHAT_RESTORE_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();

    @objc.IBAction
    def mail_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('RESTORE', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_RESTORE_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        if not os.system('unzip -o -d /Users/' + str(crtus) + '/Desktop/ /Users/' + str(crtus) + '/Desktop/****-**-**_mailbackup.zip'):
            os.system('killall Mail')
            os.system('rm -f -r /Users/' + str(crtus) + '/Library/Mail /Users/' + str(crtus) + '/Library/Preferences/com.apple.mail.plist')
            os.system('mv /Users/' + str(crtus) + '/Desktop/Mail /Users/' + str(crtus) + '/Library/')
            os.system('mv /Users/' + str(crtus) + '/Desktop/Preferences/com.apple.mail.plist /Users/' + str(crtus) + '/Library/Preferences/')
            os.system('rm -f -r /Users/' + str(crtus) + '/Desktop/Preferences')
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('MAIL_RESTORE_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('MAIL_RESTORE_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();

    @objc.IBAction
    def safari_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('RESTORE', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_RESTORE_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        if not os.system('unzip -o -d /Users/' + str(crtus) + '/Desktop/ /Users/' + str(crtus) + '/Desktop/****-**-**_safaribackup.zip'):
            os.system('killall Safari')
            os.system('rm -f -r /Users/' + str(crtus) + '/Library/Safari /Users/' + str(crtus) + '/Library/Preferences/com.apple.Safari.plist')
            os.system('mv /Users/' + str(crtus) + '/Desktop/Safari /Users/' + str(crtus) + '/Library/')
            os.system('mv /Users/' + str(crtus) + '/Desktop/Preferences/com.apple.Safari.plist /Users/' + str(crtus) + '/Library/Preferences/')
            os.system('rm -f -r /Users/' + str(crtus) + '/Desktop/Preferences')
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('SAFARI_RESTORE_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('SAFARI_RESTORE_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
		
    @objc.IBAction
    def things_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('RESTORE', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_RESTORE_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        if not os.system('unzip -o -d /Users/' + str(crtus) + '/Desktop/ /Users/' + str(crtus) + '/Desktop/****-**-**_thingsbackup.zip'):
            os.system('killall Things')
            os.system('rm -f -r /Users/' + str(crtus) + '/Library/Application\ Support/Cultured\ Code')
            os.system('mv /Users/' + str(crtus) + '/Desktop/Cultured\ Code /Users/' + str(crtus) + '/Library/Application\ Support/')
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('THINGS_RESTORE_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('THINGS_RESTORE_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();

    @objc.IBAction
    def thunderbird_(self, sender):
        alert = NSAlert.alloc().init()
        alert.setMessageText_(NSLocalizedString('RESTORE', ''))
        alert.setInformativeText_(NSLocalizedString('ALCEDO_RESTORE_STARTS', ''))
        alert.setAlertStyle_(NSInformationalAlertStyle)
        buttonPressed=alert.runModal();
        self.indicator.startAnimation_(self)
        if not os.system('unzip -o -d /Users/' + str(crtus) + '/Desktop/ /Users/' + str(crtus) + '/Desktop/****-**-**_thunderbirdbackup.zip'):
            os.system('killall thunderbird-bin')
            os.system('rm -f -r /Users/' + str(crtus) + '/Library/Thunderbird')
            os.system('mv /Users/' + str(crtus) + '/Desktop/Thunderbird /Users/' + str(crtus) + '/Library/')
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Glass.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('DONE', ''))
            alert.setInformativeText_(NSLocalizedString('THUNDERBIRD_RESTORE_COMPLETE', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();
        else:
            self.indicator.stopAnimation_(self)
            sound = NSSound.alloc()
            sound.initWithContentsOfFile_byReference_('/System/Library/Sounds/Frog.aiff', True)
            sound.play()
            alert = NSAlert.alloc().init()
            alert.setMessageText_(NSLocalizedString('FAIL', ''))
            alert.setInformativeText_(NSLocalizedString('THUNDERBIRD_RESTORE_FAIL', ''))
            alert.setAlertStyle_(NSInformationalAlertStyle)
            buttonPressed=alert.runModal();